var BatchEdit = Class.create();
BatchEdit.prototype = {
  initialize: function()
  {
    Event.observe(window, 'load', this.bindEvents.bind(this));

    this.photo_sep = 'photo-';
    this.photo_title = this.photo_sep+'title-';
    this.photo_description = this.photo_sep+'description-';
    this.photo_delete = this.photo_sep+'delete-';
    this.photo_ordering = 'order';
    this.photo_selected = 'cb_';
    this.photos_list = 'photos-edit-list';
    this.move_up = 'move-up-';
    this.move_down = 'move-down-';
    this.inplace_title_options = {okButton: false, submitOnBlur: true, cancelText: friendlyalbum.message['cancelText'], savingText: friendlyalbum.message['savingText'], loadingText: friendlyalbum.message['loadingText'], clickToEditText: friendlyalbum.message['clickToEditText'], callback: function(form, value){
      return "value="+encodeURIComponent(value);
    }};
    
    this.inplace_description_options = {rows:3, cols:45, okButton: false, submitOnBlur: true, cancelText: friendlyalbum.message['cancelText'], savingText: friendlyalbum.message['savingText'], loadingText: friendlyalbum.message['loadingText'], clickToEditText: friendlyalbum.message['clickToEditText'], callback: function(form, value){
      return "value="+encodeURIComponent(value);
      }};

    this.editors = {};
  },

  editorTitle: function(node)
  {
    var item_id = node.id.substring(this.photo_title.length);
    var url = item_id+'/setTitle';

    this.editors[node.id] = new Ajax.InPlaceEditor(node.id, url, this.inplace_title_options);
  },

  editorDescription: function(node)
  {
    var item_id = node.id.substring(this.photo_description.length);
    var url = item_id+'/setDescription';

    this.editors[node.id] = new Ajax.InPlaceEditor(node.id, url, this.inplace_description_options);
  },

  deletePhoto: function(event, node)
  {
    if(event)
      {
	Event.stop(event);
	var node = Event.element(event);
	var item_id = node.id.substring(this.photo_delete.length);
      }    
    else
      var item_id = node.id.substring(this.photo_selected.length);
    
    
    var url = "deletePhoto";
    var pars = "id="+encodeURIComponent(item_id);

    if(!event || confirm(friendlyalbum.message['confirmDeleteText']))
      {
	var photo_delete = new Ajax.Request(url, 
	    {
	      method: 'post',
	      parameters: pars
	    });
	
	new Effect.DropOut(node.parentNode.parentNode.parentNode);
      }
  },

  moveUp: function(event)
  {
    Event.stop(event);
    var node = Event.element(event);
    if(node.id)
      {
	var node_id = node.id;
      }
    else
      {
	var node_id = node.parentNode.id;
      }

    var item_id = node_id.substring(this.move_up.length);

    var seq = Sortable.sequence(this.photos_list);
    for(var i=1; i<seq.length; i++)
      {
	if(seq[i] == item_id)
	  {
	    seq[i] = seq[i-1];
	    seq[i-1] = item_id;
	    break;
	  }
      }
    Sortable.setSequence(this.photos_list, seq);
    this.updatePos();
  },

  moveDown: function(event)
  {
    Event.stop(event);
    var node = Event.element(event);
    if(node.id)
      {
	var node_id = node.id;
      }
    else
      {
	var node_id = node.parentNode.id;
      }

    var item_id = node_id.substring(this.move_down.length);

    var seq = Sortable.sequence(this.photos_list);
    for(var i=0; i<(seq.length-1); i++)
      {
	if(seq[i] == item_id)
	  {
	    seq[i] = seq[i+1];
	    seq[i+1] = item_id;
	    break;
	  }
      }
    Sortable.setSequence(this.photos_list, seq);
    this.updatePos();
  },

  updatePos: function(container)
  {
    var positions = Sortable.sequence(this.photos_list);
    var pars = '';

    for(var i=0; i<positions.length; i++)
      {
	if(i!=0)
	  {
	    pars += '&';
	  }
	pars += this.photo_ordering+'='+positions[i];
      }

    var reorder = new Ajax.Request(
				  'reorder', 
	{
	  parameters: pars,
	  onComplete: function(){new Effect.Highlight('photos-edit-list');}
	});
  },

  deleteSelected: function(event, node)
  {
    var node = Event.element(event);
    Event.stop(event);

    for(var i=2; i<node.elements.length; i++)
      {
	if(node.elements[i].checked)
	  {
	    this.deletePhoto(null, node.elements[i]);
	    node.elements[i].checked = false;
	  }
      }
  },

  bindEvents: function()
  {
    var els = document.getElementsByClassName('photoTitle');
    for(var i=0; i<els.length; i++)
      {
	this.editorTitle(els[i]);
      }

    els = document.getElementsByClassName('photoDescription');
    for(var i=0; i<els.length; i++)
      {
        this.editorDescription(els[i]);
      }

    els = document.getElementsByClassName('photoDelete');
    for(var i=0; i<els.length; i++)
      {
	Event.observe(els[i], 'click', this.deletePhoto.bindAsEventListener(this));
	els[i].onclick = function(){return false;};
      }

    
    els = document.getElementsByClassName('folderMoveUp');
    for(var i=0; i<els.length; i++)
      {
	Event.observe(els[i], 'click', this.moveUp.bindAsEventListener(this));
	els[i].onclick = function(){return false;};
      }

    els = document.getElementsByClassName('folderMoveDown');
    for(var i=0; i<els.length; i++)
      {
	Event.observe(els[i], 'click', this.moveDown.bindAsEventListener(this));
	els[i].onclick = function(){return false;};
      }
    

    var formDelete = $('folderContentsForm');
    Event.observe(formDelete, 'submit', this.deleteSelected.bindAsEventListener(this));
    formDelete.onsubmit = function(){return false;};

    Sortable.create(this.photos_list, {onUpdate: this.updatePos.bindAsEventListener(this), handle: ['photoOrdering', 'photoActions', 'photoThumb']});

  }

};

var _batch_edition = new BatchEdit;
